package org.processmining.experiments;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.text.ParseException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class CSVImport {
	Map<String, String> id_mod = new HashMap<String, String>();
	String url = "C:/Users/310187521/Desktop/PhD Docs/LUMC/1906LUMC/DataProcessing";
	static Set<String> lastAct = new HashSet<String>();

	public static void main(String[] args) throws IOException, ParseException {
		counts();
		CSVImport obj = new CSVImport();
		System.out.println("Don1e");
		System.out.println(30.3 - 36.9);

	}

	public static Map<String, String> getAwareOfModuleMap() throws IOException, ParseException {

		String inputFile2 = "C:/Users/310187521/Desktop/PhD Docs/Paper/Scitepress_conf/LUMC_Analysis/achieved_Pers_Goals.csv";
		BufferedReader br2 = null;
		String line = "";
		String cvsSplitBy = ";";

		Map<String, String> caseIdAwareMap = new HashMap<String, String>();

		try {
			br2 = new BufferedReader(new FileReader(inputFile2));
			while ((line = br2.readLine()) != null) {
				String[] row = line.split(cvsSplitBy);
				caseIdAwareMap.put(row[0], row[1]);
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
		}
		return caseIdAwareMap;
	}

	public static void printSynthesis() throws IOException, ParseException {

		String inputFile2 = "C:/Users/310187521/Desktop/PhD Docs/Paper/IPM_llncsformat/Experiments/eventlog.csv";
		BufferedReader br2 = null;
		String line = "";
		String cvsSplitBy = ";";

		Map<String, String> caseIdAwareMap = new HashMap<String, String>();

		try {
			br2 = new BufferedReader(new FileReader(inputFile2));
			while ((line = br2.readLine()) != null) {
				if (line.contains("start") || line.contains("end")) {
					if (!line.contains("Selected"))
						System.out.println(line);
				}
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
		}

	}

	public static void printSynthesisWithCountAndTime() throws IOException, ParseException {

		String inputFile2 = "C:/Users/310187521/Desktop/PhD Docs/Paper/IPM_llncsformat/Experiments/eventlog2.txt";
		BufferedReader br2 = null;
		String line = "";
		String cvsSplitBy = ";";

		Map<String, String> caseIdAwareMap = new HashMap<String, String>();

		try {
			br2 = new BufferedReader(new FileReader(inputFile2));
			while ((line = br2.readLine()) != null) {
				if (line.contains("PP") || line.contains("Seq") || line.contains("Choice"))
					System.out.println("i++; timeNow = System.currentTimeMillis();");
				System.out.println(line);
				if (line.contains("PP") || line.contains("Seq") || line.contains("Choice"))
					System.out.println("printStats(i, 0, ipn, timeNow);");

			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
		}

	}

	public static void counts() throws IOException, ParseException {

		String inputFile2 = "C:/Users/310187521/Desktop/PhD Docs/Paper/IPM_llncsformat/Experiments/BPI2012/eventlog2.txt";
		BufferedReader br2 = null;
		String line = "";
		String cvsSplitBy = ";";

		Map<String, String> caseIdAwareMap = new HashMap<String, String>();
		int ppc = 0;
		int cho = 0;
		int seq = 0;
		try {
			br2 = new BufferedReader(new FileReader(inputFile2));
			while ((line = br2.readLine()) != null) {
				if (line.contains("PP"))
					ppc++;
				if (line.contains("Seq"))
					seq++;
				if (line.contains("Cho"))
					cho++;
			}
			System.out.println("PP : " + ppc + " Choice " + cho + " Seq " + seq);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
		}

	}
}
