package org.processmining.humbertogarciacaballero.models.gui.controllers;

import java.awt.event.MouseEvent;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;

import prefuse.controls.FocusControl;
import prefuse.data.Node;
import prefuse.data.tuple.TupleSet;
import prefuse.visual.VisualItem;

public class NodeClickControlPMD extends FocusControl {

	private TupleSet startSet;
	private TupleSet graphNodes;
	private String selectedActivity;
	private TupleSet endSet;
	private TupleSet selectedInput;
	private TupleSet selectedOutput;
	NodeHighlightControlPMD nhc;
	PNetVisualizerController controller;
	private static final String TRANSITION = "TRANSITION";
	private static final String PLACE = "PLACE";

	private boolean input;
	private boolean output;

	public NodeClickControlPMD(TupleSet graphNodes, String activity, PNetVisualizerController controller) {
		super(activity);
		this.graphNodes = graphNodes;
		this.controller = controller;
		this.nhc = new NodeHighlightControlPMD(activity);
	}

	public void itemClicked(VisualItem item, MouseEvent e) {
		//focussedSet.addTuple(item);
		if (controller.getActivity() == null)
			return;
		Node item2 = (Node) item.getSourceTuple();
		if (input)
			startSet.addTuple(item2);
		else if (output) {
			endSet.addTuple(item2);
		}
		//ends
		controller.executeLayout(false);
	}

}
