package org.processmining.humbertogarciacaballero.models.model;

import prefuse.Constants;

public enum NodeType {
	PLACE(Constants.SHAPE_ELLIPSE), TRANSITION(PNConstants.SHAPE_TRANSITION), IOR(Constants.SHAPE_DIAMOND),  AND(Constants.SHAPE_DIAMOND), XOR(Constants.SHAPE_DIAMOND);
	
    private int shape;
    
    private NodeType(int shape) {
        this.shape = shape;
    }
    
	public NodeType opposite() {
		if (this == PLACE) return TRANSITION;
		return PLACE;
	}
	
	public int getShape() {
	    return shape;
	}
}
