package org.processmining.prabhakardixit.alignments.visualization;

import javax.swing.JComponent;

import org.deckfour.xes.model.XLog;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.logenhancement.view.LogViewContextProM;
import org.processmining.logenhancement.view.LogViewVisualizer;
import org.processmining.prabhakardixit.alignments.ProjectedAveragedAlignments;
import org.processmining.prabhakardixit.alignments.TransPairAlignment;

public class ExploreTraceVariants {

	public static JComponent getResult(TransPairAlignment tpa, XLog completeLog, PluginContext pluginContext) {
		XLog log = ProjectedAveragedAlignments.createMergedLog(completeLog, tpa.getActivities(),true);
		return new LogViewVisualizer(new LogViewContextProM(pluginContext), log);
		
	}
	
}
