package org.processmining.prabhakardixit.alignments.visualization;

import javax.swing.JComponent;

import org.deckfour.xes.model.XLog;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.plugins.petrinet.replayresult.visualization.PNLogReplayResultVisPanel;
import org.processmining.prabhakardixit.alignments.ProjectedAveragedAlignments;
import org.processmining.prabhakardixit.alignments.TransPairAlignment;

public class ProjectAlignmentToLogView {

	public static JComponent getResult(TransPairAlignment tpa, XLog completeLog, PluginContext pluginContext) {
		XLog log = ProjectedAveragedAlignments.createMergedLog(completeLog, tpa.getActivities(),true);
		PNLogReplayResultVisPanel pan = new PNLogReplayResultVisPanel(log, tpa.getReplayResult(), pluginContext.getProgress());
		return pan;
		
	}

	
	
}
