//package org.processmining.prabhakardixit.fcnets.expansion;
//
//import java.util.Collection;
//import java.util.HashSet;
//import java.util.Set;
//
//import org.ejml.simple.SimpleMatrix;
//import org.processmining.models.graphbased.directed.petrinet.PetrinetEdge;
//import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
//import org.processmining.models.graphbased.directed.petrinet.elements.Place;
//import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
//import org.processmining.prabhakardixit.fcnets.matrix.MatrixUtils;
//import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;
//import org.processmining.prabhakardixit.fcnets.models.PetriNetMap;
//
//public class AddNewTranBwPlaceAndTran_1 {
//	public static void addTranBwPlaceAndTransition(Set<Place> placeSet, Set<Transition> tranSet, String transitionName,
//			InteractivePetriNet ipn) {
//		PetriNetMap pnmap = ipn.getselectedPetriNetMap();
//		Transition tNew = pnmap.getPetriNet().addTransition(transitionName);
//		if(transitionName.trim()=="")
//			tNew.setInvisible(true);
//		Place pNew = pnmap.getPetriNet().addPlace(transitionName);
//		ipn.setPlaceId(pNew, ipn.getAllPlaceId().size());
//		ipn.setTranId(tNew, ipn.getAllTranId().size());
//		boolean isLoopStartOrEnd = false;
//		
//		Collection<PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode>> outEdges = null;
//		for (Place p : placeSet) {
//			pnmap.getPetriNet().addArc(p, tNew);
//			if (outEdges == null)
//				outEdges = pnmap.getPetriNet().getOutEdges(p);
//			else
//				outEdges.addAll(pnmap.getPetriNet().getOutEdges(p));
//		}
//		pnmap.getPetriNet().addArc(tNew, pNew);
//		for (Transition t : tranSet)
//			pnmap.getPetriNet().addArc(pNew, t);
//
//		for (PetrinetEdge<? extends PetrinetNode, ? extends PetrinetNode> e : outEdges)
//			if (tranSet.contains(e.getTarget()))
//				pnmap.getPetriNet().removeEdge(e);
//
//		//new code starts
//
//		updateIncidenceMatrix(placeSet, tranSet, ipn, pNew, tNew);
//		//new code ends
//		
//
//	}
//
//	private static void updateIncidenceMatrix(Set<Place> placeSet, Set<Transition> tranSet, InteractivePetriNet ipn,
//			Place pNew, Transition tNew) {
//		SimpleMatrix incidenceMatrixInput = ipn.getIncidenceMatrixInput();
//		SimpleMatrix incidenceMatrixOutput = ipn.getIncidenceMatrixOutput();
//		SimpleMatrix emptyRow = new SimpleMatrix(1, incidenceMatrixInput.numCols());
//		SimpleMatrix emptyCol = new SimpleMatrix(incidenceMatrixInput.numRows(), 1);
//		incidenceMatrixInput = incidenceMatrixInput.combine(incidenceMatrixInput.numRows(), 0, emptyRow); //increase incidence Matrix with new row/col
//		incidenceMatrixInput = incidenceMatrixInput.combine(0, incidenceMatrix.numCols(), emptyCol);
//		Set<Integer> placeIDs = new HashSet<Integer>();
//		Set<Integer> tranIDs = new HashSet<Integer>();
//		int newRow = ipn.getPlaceId(pNew);
//		int newCol = ipn.getTranId(tNew); //new T id
//		for (Place p : placeSet)
//			placeIDs.add(ipn.getPlaceId(p));
//		for (Transition t : tranSet)
//			tranIDs.add(ipn.getTranId(t));
//		for (Integer row : placeIDs) {
//			for (Integer col : tranIDs) {
//				incidenceMatrix.set(row, col, 0); //set prev p->t to zero (from -1)
//			}
//			int col = ipn.getTranId(tNew);
//			incidenceMatrix.set(row, col, -1); //set prev p->tNew to -1 
//		}
//
//		for (Integer col : tranIDs) {
//			incidenceMatrix.set(newRow, col, -1); //set new p->tOld to -1 
//		}
//		incidenceMatrix.set(newRow, newCol, 1);
//		ipn.setInciMatrix(incidenceMatrix);
//		//update TranLD
//		MatrixUtils.updateTranLD(ipn,placeIDs,newRow);
//		MatrixUtils.updatePlaceLD(ipn,tranIDs,newCol);
//		MatrixUtils.printMatrix(incidenceMatrix);
//	}
//
//	
//
//	public static void addTranBwPlaceAndTransition(Place pl, Transition tr, String string, PetriNetMap pn) {
//		Set<Place> plSet = new HashSet<Place>();
//		Set<Transition> trSet = new HashSet<Transition>();
//		plSet.add(pl);
//		trSet.add(tr);
//		//		addTranBwPlaceAndTransition(plSet, trSet, string, pn, 0, 0);
//	}
//
//	public static void addTranBwPlaceAndTransition(Place pl, Transition tr, String string, InteractivePetriNet ipn) {
//		Set<Place> plSet = new HashSet<Place>();
//		Set<Transition> trSet = new HashSet<Transition>();
//		plSet.add(pl);
//		trSet.add(tr);
//		addTranBwPlaceAndTransition(plSet, trSet, string, ipn);
//	}
//
//	
//}
