//package org.processmining.prabhakardixit.fcreduction;
//
//import java.io.FileWriter;
//import java.io.IOException;
//import java.util.Collection;
//import java.util.HashMap;
//import java.util.HashSet;
//import java.util.Map;
//import java.util.Set;
//
//import org.deckfour.xes.classification.XEventClass;
//import org.deckfour.xes.extension.std.XConceptExtension;
//import org.deckfour.xes.info.XLogInfo;
//import org.deckfour.xes.info.XLogInfoFactory;
//import org.deckfour.xes.info.impl.XLogInfoImpl;
//import org.deckfour.xes.model.XEvent;
//import org.deckfour.xes.model.XLog;
//import org.deckfour.xes.model.XTrace;
//import org.processmining.acceptingpetrinet.models.AcceptingPetriNet;
//import org.processmining.acceptingpetrinet.models.AcceptingPetriNetArray;
//import org.processmining.acceptingpetrinet.models.impl.AcceptingPetriNetArrayImpl;
//import org.processmining.acceptingpetrinet.models.impl.AcceptingPetriNetImpl;
//import org.processmining.framework.plugin.PluginContext;
//import org.processmining.models.graphbased.directed.petrinet.Petrinet;
//import org.processmining.models.graphbased.directed.petrinet.elements.Place;
//import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
//import org.processmining.models.graphbased.directed.petrinet.impl.PetrinetImpl;
//import org.processmining.models.semantics.petrinet.Marking;
//import org.processmining.prabhakardixit.fcnets.models.PetriNetMap;
//import org.processmining.prabhakardixit.pnets.PetrinetCompare;
//import org.processmining.processtree.conversion.ProcessTree2Petrinet.PetrinetWithMarkings;
//
//public class FreeChoicePNGenerator {
//
//	static Map<String, Map<String, Integer>> eventID = new HashMap<String, Map<String, Integer>>();
//	static Set<String> start = new HashSet<String>();
//	static Set<String> last = new HashSet<String>();
//	static Collection<XEventClass> events;
//	static Set<AcceptingPetriNet> apnSet = new HashSet<AcceptingPetriNet>();
//	static Set<PetriNetMap> mapPetriNetSet = new HashSet<PetriNetMap>();
//	static Set<Petrinet> petriNetSet = new HashSet<Petrinet>();
//
//	public static AcceptingPetriNetArray createPN(XLog log,PluginContext context) {
//		XLogInfo info = XLogInfoFactory.createLogInfo(log, XLogInfoImpl.NAME_CLASSIFIER);
//		events = info.getEventClasses().getClasses();
//		PetrinetWithMarkings pwm = initialize();
//
//		AcceptingPetriNet apn = new AcceptingPetriNetImpl(pwm.petrinet, pwm.initialMarking, pwm.finalMarking);
//		apnSet.add(apn);
//		mapPetriNetSet.clear();
//		petriNetSet.clear();
//		
////		ShortCutRule.bruteForceShortcut(apn.getNet());
//		
//		/*for (XEventClass event : events) {
//
//			for (Place p : pwm.petrinet.getPlaces()) {
//				
//				if (pwm.initialMarking.contains(p) || pwm.finalMarking.contains(p))
//					continue;
//				for (XEventClass evt : events) {
//					PetriNetMap pnmap = new PetriNetMap(pwm.petrinet);
//					mapPetriNetSet.addAll(ShortCutRule.shortCutPlace(pnmap, p, evt.toString()));
//				}
//			}
//		}*/
//
//		for (XTrace t : log) {
//			for (XEvent e : t) {
//				String eventName = XConceptExtension.instance().extractName(e);
//				//	events.add(eventName);
//			}
//		}
//		AcceptingPetriNetArray apnArr = new AcceptingPetriNetArrayImpl();
//		for (Petrinet mpn : petriNetSet) {
//			
//			AcceptingPetriNet apn1 = new AcceptingPetriNetImpl(mpn);
//			apnArr.addNet(apn1);
//		}
//		
//		PetrinetWithMarkings pwm2 = initialize();
//		AcceptingPetriNet apn2 = new AcceptingPetriNetImpl(pwm2.petrinet, pwm2.initialMarking, pwm2.finalMarking);
//		apnArr.addNet(apn2);
//		return apnArr;
//
//	}
//
//	/*
//	 * private static void shortcut(Petrinet pn) { for(XEventClass e : events){
//	 * for(Place p : pn.getPlaces()){ if(p.getLabel().equals("i") ||
//	 * p.getLabel().equals("o")) continue;
//	 * 
//	 * } }
//	 * 
//	 * }
//	 */
//
//	private static PetrinetWithMarkings initialize() {
//		PetrinetWithMarkings pwm = new PetrinetWithMarkings();
//		Petrinet pn = new PetrinetImpl("pn");
//		Place pi = pn.addPlace("i");
//		Place po = pn.addPlace("o");
//		Place pm = pn.addPlace("m");
//		Transition ti = pn.addTransition("taustart");
//		Transition to = pn.addTransition("tauend");
//		ti.setInvisible(true);
//		to.setInvisible(true);
//		pn.addArc(pi, ti);
//		pn.addArc(ti, pm);
//		pn.addArc(pm, to);
//		pn.addArc(to, po);
//		Marking i = new Marking();
//		i.add(pi);
//		Marking f = new Marking();
//		f.add(po);
//		pwm.petrinet = pn;
//		pwm.finalMarking = f;
//		pwm.initialMarking = i;
//		//ShortCutRule.shortCut(pn);
//		return pwm;
//	}
//
//	private static void writecsv() throws IOException {
//		// TODO Auto-generated method stub
//		String path = "C:/Users/310187521/Desktop/test112.csv";
//		FileWriter writer = new FileWriter(path);
//		//FileReader reader = new FileReader(path);
//		//writer.append(reader.toString());
//		for (String event : eventID.keySet()) {
//			for (String string : eventID.get(event).keySet()) {
//				writer.append(event);
//				writer.append(";");
//				writer.append(string);
//				writer.append(";");
//				writer.append(eventID.get(event).get(string).toString());
//				writer.append("\n");
//			}
//		}
//		writer.append("\n\n\n");
//		for (String s : start) {
//			writer.append("\n");
//			writer.append(s);
//		}
//		writer.append("\n");
//		writer.flush();
//		writer.close();
//	}
//	
//	protected static boolean containsPetriNet(Petrinet pn) {
//		for (Petrinet pnet : petriNetSet) {
//			if (PetrinetCompare.comparePetriNets(pn, pnet))
//				return true;
//		}
//		return false;
//	}
//
//}
