package org.processmining.prabhakardixit.pluginsPN;

import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class SortTransitionsBasedOnPlaces implements Comparable<SortTransitionsBasedOnPlaces> {

	private Transition transition;
	private Integer nbrOfEdges;

	public SortTransitionsBasedOnPlaces(Transition enabledTransition, int nbrOfPlaceOutEdges) {
		setTransition(enabledTransition);
		setNbrOfEdges(nbrOfPlaceOutEdges);
	}

	@Override
	public int compareTo(SortTransitionsBasedOnPlaces o) {
		return getNbrOfEdges().compareTo(o.getNbrOfEdges());
	}

	public Transition getTransition() {
		return transition;
	}

	public void setTransition(Transition transition) {
		this.transition = transition;
	}

	public Integer getNbrOfEdges() {
		return nbrOfEdges;
	}

	public void setNbrOfEdges(Integer nbrOfEdges) {
		this.nbrOfEdges = nbrOfEdges;
	}
}