package org.processmining.prabhakardixit.processanalytics;

import java.util.HashSet;
import java.util.Set;

import org.processmining.models.graphbased.directed.petrinet.elements.Transition;

public class CaseLevelInfo {

	protected Integer syncId;
	protected Set<Transition> syncTrans;
	protected Set<Transition> modelMoveTrans;
	protected Set<String> logMoves;
	protected Integer numOfTraces;

	public CaseLevelInfo(Integer syncId, Integer numTraces){
		this.syncId = syncId;
		this.syncTrans=new HashSet<Transition>();
		this.modelMoveTrans=new HashSet<Transition>();
		this.logMoves = new HashSet<String>();
		this.numOfTraces = numTraces;
	}
	
	public Integer getSyncId() {
		return syncId;
	}

	public void setSyncId(Integer syncId) {
		this.syncId = syncId;
	}

	public Set<Transition> getSyncTrans() {
		return syncTrans;
	}

	public void setSyncTrans(Transition syncTrans) {
		this.syncTrans.add(syncTrans);
	}

	public Set<Transition> getModelMoveTrans() {
		return modelMoveTrans;
	}

	public void setModelMoveTrans(Transition modelMoveTran) {
		this.modelMoveTrans.add(modelMoveTran);
	}

	public Set<String> getLogMoves() {
		return logMoves;
	}

	public void setLogMoves(String logMove) {
		this.logMoves.add(logMove);
	}

	public Integer getNumOfTraces() {
		return numOfTraces;
	}

	public void setNumOfTraces(Integer numOfTraces) {
		this.numOfTraces = numOfTraces;
	}

}
