package org.processmining.dataquality.Reasons;

import java.util.ArrayList;
import java.util.List;

import org.processmining.dataquality.Reasons.ReasonMapping.Reasons;

public class Reason {

	int id;

	Reasons reason ;
	List<String> activities;
	int numCasesWithIssues; //num of cases which had this pattern
	int numIssues; //num of times this pattern occurred
	int totInstances; //total occurrences of this (set of) act happened

	public Reason(List<String> acts, int numIssues, int numCasesWithIssues, Reasons reason) {
		activities = new ArrayList<String>(acts);
		this.numIssues = numIssues;
		this.numCasesWithIssues = numCasesWithIssues;
		this.reason = reason;
		this.id = this.hashCode();
	}

	public Reason(String s, Integer numIssues, int numCasesWithIssues, Reasons reason) {
		List<String> acts = new ArrayList<String>();
		acts.add(s);
		new Reason(acts,numIssues,numCasesWithIssues,reason);
	}

	public Reasons getReason() {
		return reason;
	}

	public void setReason(Reasons reason) {
		this.reason = reason;
	}

	public List<String> getActivities() {
		return activities;
	}

	public void setActivities(List<String> activities) {
		this.activities = activities;
	}

	public int getNumCasesWithIssues() {
		return numCasesWithIssues;
	}

	public void setNumCasesWithIssues(int numCasesWithIssues) {
		this.numCasesWithIssues = numCasesWithIssues;
	}

	public int getNumIssues() {
		return numIssues;
	}

	public void setNumIssues(int numIssues) {
		this.numIssues = numIssues;
	}

	public int getTotInstances() {
		return totInstances;
	}

	public void setTotInstances(int totInstances) {
		this.totInstances = totInstances;
	}
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

}
