package org.processmining.discovery;

import java.util.HashSet;
import java.util.Set;

import javax.swing.JPanel;

import org.processmining.humbertogarciacaballero.models.controller.PNetVisualizerController;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;
import org.processmining.models.graphbased.directed.petrinet.elements.Transition;
import org.processmining.reduction.Reduction;

public class DiscoveryPredictor {

	//TODO extend this to include more discovery algos
	public static void discover(PNetVisualizerController controller) {
		JPanel panel = controller.getStatisticsPanel();
		panel.removeAll();
//		panel.add(DiscoveryUsingIM.getArray(controller.getActivity(), controller.getIPN(), panel.getWidth(),
//				panel.getHeight()));
		panel.revalidate();
		panel.repaint();

	}

	public static void reduce(PNetVisualizerController controller) {
		Set<PetrinetNode> keepNodes = new HashSet<PetrinetNode>();
		for (Transition t : controller.getIPN().getselectedPetriNetMap().getPetriNet().getTransitions())
			if (t.getLabel() != "a")
				keepNodes.add(t);
		Reduction rd = new Reduction(controller.getIPN().getselectedPetriNetMap().getPetriNet(), keepNodes);

	}
}
