package org.processmining.discovery;

import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.prabhakardixit.fcnets.models.InteractivePetriNet;

@Plugin(name = "Expt Petri net 13 discovery", parameterLabels = { "Log " }, returnLabels = { "Name of your output" }, returnTypes = { InteractivePetriNet.class })
public class LogInput {
//
//	/**
//	 * The method that does the heavy lifting for your plug-in.
//	 * 
//	 * Note that this method only uses the boolean which is stored in the
//	 * configuration. Nevertheless, it could have used the integer and/or the
//	 * String as well.
//	 * 
//	 * @param context
//	 *            The context where to run in.
//	 * @param input1
//	 *            The first input.
//	 * @param dclist
//	 * @param log
//	 * @param input2
//	 *            The second input.
//	 * @param configuration
//	 *            The configuration to use.
//	 * @return The output.
//	 * @throws InstantiationException
//	 * @throws IllegalAccessException
//	 */
//	static Set<String> events = new HashSet<String>();
//
//	public InteractivePetriNet yourPrivatePlugin(PluginContext context, XLog log) throws IllegalAccessException,
//			InstantiationException {
////		VizToPnetMapper.log = false;
//		long timeNow = System.currentTimeMillis();
//		InteractivePetriNet ipn = CreateIPN.createIPN(log, context);
//		MatrixUtils.initiate(ipn);
//		Petrinet pn = ipn.getselectedPetriNetMap().getPetriNet();
//		Random random = new Random();
//
//		RecomputeAlignments.doAlignments(ipn,"a");
//		
//		int parPlacs = 5 * 3;
//		int choiceTrans = 19 * 3;
//		int seqUences = 24 * 3;
//
//		int iMax = choiceTrans + parPlacs + seqUences;
//		for (int i = 0; i < iMax; i++) {
//			boolean contains = false;
//			int opType = random.nextInt(5);
//			if (i == 0) //start with seq
//				opType = 3;
//			while (!contains) {
//				opType = random.nextInt(5);
//				switch (opType) {
//					case 0 :
//						if (parPlacs > 0) {
//							contains = true;
//							parPlacs--;
//						}
//						break;
//					case 1 :
//						if (choiceTrans > 0) {
//							contains = true;
//							choiceTrans--;
//						}
//						break;
//					case 2 :
//					case 3 :
//						if (seqUences > 0) {
//							contains = true;
//							seqUences--;
//						}
//						break;
//				}
//			}
//			timeNow = System.currentTimeMillis();
//
//			switch (opType) {
//				case 0 :
//					SynthesizeNets.addParallelPlace(ipn);
//					break;
//				case 1 :
//					SynthesizeNets.addChoiceTran(ipn);
//					break;
//				case 2 :
//					SynthesizeNets.addSequence(ipn, 1);
//					break;
//				case 3 :
//					SynthesizeNets.addSequence(ipn, 2);
//					break;
//				case 4 :
//					SynthesizeNets.addChoiceTran(ipn);
//					break;
//				default :
//					SynthesizeNets.addSequence(ipn, 2);
//					break;
//			}
//
//			System.out.println("Iteration: " + i + " Op Type: " + opType + " # trans : " + pn.getTransitions().size()
//					+ " # places " + pn.getPlaces().size() + " Size of place ld mat : "
//					+ ipn.getAllLdPlaceInfo().size() + " Size of tran ld mat : " + ipn.getAllLdTranInfo().size()
//					+ " Size of place ld FC mat : " + ipn.getplaceLDNonSiphons().size()
//					+ " Size of tran ld FC non Sip mat : " + ipn.getTranLDFCs().size() + " time diff in millis "
//					+ (System.currentTimeMillis() - timeNow));
//			//			}
//		}
//
//		//		System.out.println("Time diff1");
//		//		System.out.println(System.currentTimeMillis() - timeNow);
//		//		timeNow = System.currentTimeMillis();
//		//		SynthesizeNets.addParallelPlace(ipn);
//		//		System.out.println(System.currentTimeMillis() - timeNow);
//		//		timeNow = System.currentTimeMillis();
//		//		SynthesizeNets.addSequence(ipn, 1);
//		//		System.out.println(System.currentTimeMillis() - timeNow);
//		//		timeNow = System.currentTimeMillis();
//		//		SynthesizeNets.addChoiceTran(ipn);
//		//		System.out.println(System.currentTimeMillis() - timeNow);
//		return ipn;
//	}
//
//	/**
//	 * The plug-in variant that runs in a UI context and uses a dialog to get
//	 * the configuration.
//	 * 
//	 * @param context
//	 *            The context to run in.
//	 * @param input1
//	 *            The first input.
//	 * @param input2
//	 *            The second input.
//	 * @return The output.
//	 * @throws InstantiationException
//	 * @throws IllegalAccessException
//	 */
//	@UITopiaVariant(affiliation = "TU/e", author = "P.M. Dixit", email = "p.m.dixit@tue.nl")
//	@PluginVariant(variantLabel = "Petri Net generati13on", requiredParameterLabels = { 0 })
//	public InteractivePetriNet yourDefaultPlugin(UIPluginContext context, XLog log) throws IllegalAccessException,
//			InstantiationException {
//
//		return yourPrivatePlugin(context, log);
//
//	}
}
