package org.processmining.discovery;

public class Parameters {
	private boolean duplicateLabels;
	private int maxDuplicates;
	private boolean loopsAllowed;
	private boolean exclusiveChoices;
	private boolean inclusiveChoices;
	private int ratioOfChoices;
	private boolean sequences;
	private boolean parallelisms;
	private boolean optionalActivities;
	
	
	public Parameters(){
		duplicateLabels=true;
	}

	public boolean isDuplicateLabels() {
		return duplicateLabels;
	}

	public void setDuplicateLabels(boolean duplicateLabels) {
		this.duplicateLabels = duplicateLabels;
	}

	public int getMaxDuplicates() {
		return maxDuplicates;
	}

	public void setMaxDuplicates(int maxDuplicates) {
		this.maxDuplicates = maxDuplicates;
	}

	public boolean isLoopsAllowed() {
		return loopsAllowed;
	}

	public void setLoopsAllowed(boolean loopsAllowed) {
		this.loopsAllowed = loopsAllowed;
	}

	public boolean isExclusiveChoices() {
		return exclusiveChoices;
	}

	public void setExclusiveChoices(boolean exclusiveChoices) {
		this.exclusiveChoices = exclusiveChoices;
	}

	public boolean isInclusiveChoices() {
		return inclusiveChoices;
	}

	public void setInclusiveChoices(boolean inclusiveChoices) {
		this.inclusiveChoices = inclusiveChoices;
	}

	public int getRatioOfChoices() {
		return ratioOfChoices;
	}

	public void setRatioOfChoices(int ratioOfChoices) {
		this.ratioOfChoices = ratioOfChoices;
	}

	public boolean isSequences() {
		return sequences;
	}

	public void setSequences(boolean sequences) {
		this.sequences = sequences;
	}

	public boolean isParallelisms() {
		return parallelisms;
	}

	public void setParallelisms(boolean parallelisms) {
		this.parallelisms = parallelisms;
	}

	public boolean isOptionalActivities() {
		return optionalActivities;
	}

	public void setOptionalActivities(boolean optionalActivities) {
		this.optionalActivities = optionalActivities;
	}

}
