package org.processmining.exhaustivesearch;

import java.util.Set;

import org.processmining.framework.util.Pair;
import org.processmining.models.graphbased.directed.petrinet.PetrinetNode;

public class ExhaustiveInfo {
	private static long totalTimeForLDPlaces;
	private static long totalTimeForLDTrans;
	private static int totalLDPlacesEvaluated;
	private static int totalLDTransEvaluated;
	Set<Pair<Set<PetrinetNode>, Set<PetrinetNode>>> ldPlaces;
	Set<Pair<Set<PetrinetNode>, Set<PetrinetNode>>> ldTrans;

	public static long getTotalTimeForLDPlaces() {
		return totalTimeForLDPlaces;
	}

	public Set<Pair<Set<PetrinetNode>, Set<PetrinetNode>>> getLdPlaces() {
		return ldPlaces;
	}

	public void setLdPlaces(Set<Pair<Set<PetrinetNode>, Set<PetrinetNode>>> ldPlaces) {
		this.ldPlaces = ldPlaces;
	}

	public Set<Pair<Set<PetrinetNode>, Set<PetrinetNode>>> getLdTrans() {
		return ldTrans;
	}

	public void setLdTrans(Set<Pair<Set<PetrinetNode>, Set<PetrinetNode>>> ldTrans) {
		this.ldTrans = ldTrans;
	}

	public static void setTotalTimeForLDPlaces(long totalTimeForLDPlaces) {
		ExhaustiveInfo.totalTimeForLDPlaces = totalTimeForLDPlaces;
	}

	public static long getTotalTimeForLDTrans() {
		return totalTimeForLDTrans;
	}

	public static void setTotalTimeForLDTrans(long totalTimeForLDTrans) {
		ExhaustiveInfo.totalTimeForLDTrans = totalTimeForLDTrans;
	}

	public static int getTotalLDPlacesEvaluated() {
		return totalLDPlacesEvaluated;
	}

	public static void setTotalLDPlacesEvaluated(int totalLDPlacesEvaluated) {
		ExhaustiveInfo.totalLDPlacesEvaluated = totalLDPlacesEvaluated;
	}

	public static int getTotalLDTransEvaluated() {
		return totalLDTransEvaluated;
	}

	public static void setTotalLDTransEvaluated(int totalLDTransEvaluated) {
		ExhaustiveInfo.totalLDTransEvaluated = totalLDTransEvaluated;
	}

	

}
