package org.processmining.humbertogarciacaballero.models.gui.decorator;

import java.awt.geom.Rectangle2D;
import java.util.Iterator;

import org.processmining.humbertogarciacaballero.models.util.Utils;

import prefuse.action.layout.Layout;
import prefuse.visual.AggregateItem;
import prefuse.visual.DecoratorItem;

public class BarDecoratorLayout extends Layout {

	public BarDecoratorLayout(String group) {
		super(group);
	}

	@Override
	@SuppressWarnings("unchecked")
	public void run(double frac) {
		Iterator<DecoratorItem> iter = getVisualization().items(getGroup());
		while (iter.hasNext()) {
			DecoratorItem decorator = iter.next();
			AggregateItem decoratedItem = (AggregateItem) decorator.getDecoratedItem();
			Rectangle2D bounds = Utils.getBounds(decoratedItem);

			setX(decorator, null, bounds.getX());
			setY(decorator, null, bounds.getY());
		}
	}
}
