package org.processmining.prabhakardixit.alignments;


public class AggregatedAlignmentInfo {
//	public static void getAlignmentInfo(InteractivePetriNet ipn) {
//		Set<String> allAct = new HashSet<String>();
//		for (Transition t : ipn.getselectedPetriNetMap().getPetriNet().getTransitions()) {
//			if (!t.isInvisible())
//				allAct.add(t.getLabel());
//		}
//		//merge all alignments
//		Multiset<String> logMoveCount = HashMultiset.create();
//		Multiset<Transition> modelMoveCount = HashMultiset.create();
//		Multiset<Transition> syncMoveCount = HashMultiset.create();
//		Map<String, Double> actFreqCount = new HashMap<String, Double>();
//		int numPairs = allAct.size() - 1;
//		Map<String, Integer> numTraces = new HashMap<String, Integer>(); //num traces in which act occurred
//		Map<String, Integer> numOccurrencesInTraces = new HashMap<String, Integer>(); //num traces in which act occurred
//
//		PetriNetMap pnmap = new PetriNetMap(ipn.getselectedPetriNetMap().getPetriNet());
//		ClusterNet cnet = NavigateEmptyTraces.reduceNetWithClusters(pnmap);
//		for (AggregatedTraceLevelPairwiseInfo tlpi : ipn.getPairwiseAlignmentInfo()) {
//
//			/*
//			 * Get sync and model moves for each trace (normalized) for all
//			 * pairs
//			 */
//			Multiset<Transition> syncModelMovesAll = HashMultiset.create();
//			Multiset<Transition> syncModelMoves = HashMultiset.create();
//			for (Transition t : tlpi.getSyncMoves().elementSet()) {
//				syncModelMovesAll.add(t, tlpi.getSyncMoves().count(t));
//			}
//			for (Transition t : tlpi.getModelMoves().elementSet()) {
//				syncModelMovesAll.add(t, tlpi.getModelMoves().count(t));
//			}
//			for (Transition t : syncModelMovesAll.elementSet()) {
//				syncModelMoves.add(t, syncModelMovesAll.count(t) / numPairs);
//			}
//
//			Multiset<Transition> modelMoves = NavigateEmptyTraces.getModelMoves(cnet, syncModelMoves); //TODO make this a bag instead of set	
//			modelMoveCount.addAll(modelMoves);
//			//populate log model and sync moves for complete log
//			for (String act : tlpi.getLogMoves().elementSet())
//				logMoveCount.add(act, tlpi.getLogMoves().count(act) * tlpi.getNumTraces());
//			for (Transition t : tlpi.getModelMoves().elementSet())
//				modelMoveCount.add(t, tlpi.getModelMoves().count(t) * tlpi.getNumTraces());
//			for (Transition t : tlpi.getSyncMoves().elementSet())
//				syncMoveCount.add(t, tlpi.getSyncMoves().count(t) * tlpi.getNumTraces());
//
//		}
//
//		//TODO do this during initial screening
//		for (XTrace trace : ipn.getLog()) {
//			Set<String> addedAct = new HashSet<String>();
//			Iterator iter = trace.iterator();
//			while (iter.hasNext()) {
//				String evt = XConceptExtension.instance().extractName((XEvent) iter.next());
//				if (addedAct.add(evt)) {
//					if (numTraces.containsKey(evt))
//						numTraces.put(evt, numTraces.get(evt) + 1);
//					else
//						numTraces.put(evt, 1);
//				}
//				if (numOccurrencesInTraces.containsKey(evt))
//					numOccurrencesInTraces.put(evt, numOccurrencesInTraces.get(evt) + 1);
//				else
//					numOccurrencesInTraces.put(evt, 1);
//
//			}
//
//		}
//
//		//		}
//		/*
//		 * create averages L_Act = L_total_Act / (#Pairs * #TracesWithAct)
//		 */
//
//		Map<String, Double> syncAct = new HashMap<String, Double>();
//		Map<String, Double> logMoveAct = new HashMap<String, Double>();
//		Map<String, Double> modelMoveAct = new HashMap<String, Double>();
//		for (String act : allAct) {
//			double logMove = 0;
//			logMoveAct.put(act, 0.);
//			if (logMoveCount.contains(act)) {
//				logMove = ((double) logMoveCount.count(act)) / (numPairs * numTraces.get(act));
//				System.out.println("Log Moves for " + act + " : " + logMove);
//				logMoveAct.put(act, logMove);
//			}
//		}
//		for (Transition t : ipn.getselectedPetriNetMap().getPetriNet().getTransitions()) {
//			double syncMove = 0;
//
//			if (!syncMoveCount.isEmpty() && syncMoveCount.contains(t)) {
//				syncMove = ((double) syncMoveCount.count(t)) / (numPairs * numTraces.get(t.getLabel()));
//				System.out.println("Sync Moves for " + t.getLabel() + " : " + syncMove);
//			}
//		}
//
//		for (Transition t : ipn.getselectedPetriNetMap().getPetriNet().getTransitions()) {
//			double syncMove = 0;
//
//			if (!syncAct.containsKey(t.getLabel()))
//				syncAct.put(t.getLabel(), 0.);
//			if (!syncMoveCount.isEmpty() && syncMoveCount.contains(t)) {
//				syncMove = ((double) syncMoveCount.count(t)) / (numPairs * numOccurrencesInTraces.get(t.getLabel()));
//				System.out.println("Sync Moves freq for " + t.getLabel() + " : " + syncMoveCount.count(t) / (numPairs));
//				syncAct.put(t.getLabel(), syncAct.get(t.getLabel()) + syncMove);
//				//				System.out.println(" NUm of Pairs " + numPairs.get(t.getLabel()));
//			}
//
//		}
//
//		for (Transition t : ipn.getselectedPetriNetMap().getPetriNet().getTransitions()) {
//			double modelMove = 0;
//			modelMoveAct.put(t.getLabel(), 0.);
//			if (!modelMoveCount.isEmpty() && modelMoveCount.contains(t)) {
//				modelMove = ((double) modelMoveCount.count(t))
//						/ (numPairs * (numTraces.containsKey(t.getLabel()) ? numTraces.get(t.getLabel()) : 1));
//				System.out.println("Model Moves for " + t.getLabel() + " : " + modelMove);
//				modelMoveAct.put(t.getLabel(), modelMoveAct.get(t.getLabel()) + modelMove);
//			}
//		}
//
//		for (Transition t : ipn.getselectedPetriNetMap().getPetriNet().getTransitions()) {
//			double modelMove = 0;
//			modelMoveAct.put(t.getLabel(), 0.);
//			if (!modelMoveCount.isEmpty() && modelMoveCount.contains(t)) {
//				modelMove = ((double) modelMoveCount.count(t))
//						/ (numPairs * (numOccurrencesInTraces.containsKey(t.getLabel()) ? numOccurrencesInTraces.get(t
//								.getLabel()) : 1));
//				System.out.println("Model Moves Normalized for " + t.getLabel() + " : " + modelMove);
//				modelMoveAct.put(t.getLabel(), modelMoveAct.get(t.getLabel()) + modelMove);
//			}
//		}
//
//		double totalFit = 0.;
//		int actsToConsider = 0;
//		for (String act : allAct) {
//			System.out.println("Sync Moves Normalized for " + act + " : " + syncAct.get(act));
//			if (syncAct.get(act) > 0. || modelMoveAct.get(act) > 0. || logMoveAct.get(act) > 0.) {
//				actsToConsider++;
//				totalFit += ((double) syncAct.get(act))
//						/ (syncAct.get(act) + modelMoveAct.get(act) + logMoveAct.get(act));
//			}
//
//		}
//		totalFit /= actsToConsider;
//	}
}
