package org.processmining.prabhakardixit.alignments;

import org.deckfour.xes.model.XLog;
import org.processmining.contexts.uitopia.UIPluginContext;
import org.processmining.framework.plugin.annotations.Plugin;

@Plugin(name = "Petri net editor with alignment view", parameterLabels = { "Log " }, returnLabels = { "Name of your output" }, returnTypes = { XLog.class })
public class PluginExploreLog {

	public XLog log(UIPluginContext context, XLog log) throws IllegalAccessException, InstantiationException {
		context.getProvidedObjectManager().createProvidedObject(
				"Filtered log ", log, XLog.class, context);
		context.getGlobalContext().getResourceManager().getResourceForInstance(log)
				.setFavorite(true);
		return log;
	}

}